package sandbox;

import java.nio.FloatBuffer;
import javax.media.opengl.*;

import processing.core.PGraphics3D;
import processing.core.PMatrix3D;

public class UtilsGL {

	UtilsGL() {
	}

	public static float zBuffer(processing.core.PApplet parent, float x, float y) {
		FloatBuffer zbuff = FloatBuffer.allocate(1);
		processing.opengl.PGraphicsOpenGL pogl = (processing.opengl.PGraphicsOpenGL) parent.g;
        pogl.gl.glReadPixels(parent.floor(x),
                parent.height-parent.floor(y),
                1, 1, GL.GL_DEPTH_COMPONENT, GL.GL_FLOAT, zbuff);		
		return zbuff.get();
	}
	
	public static PMatrix3D getModelview(processing.core.PApplet parent) {
		processing.opengl.PGraphicsOpenGL pogl = (processing.opengl.PGraphicsOpenGL) parent.g;
		return pogl.modelview.get(); 
	}
	
	
	public static PMatrix3D getProjection(processing.core.PApplet parent) {
		processing.opengl.PGraphicsOpenGL pogl = (processing.opengl.PGraphicsOpenGL) parent.g;
		return pogl.projection.get(); 
	}	
	
	
}
